<?php
/**
*
* @package Chat
* @version 0.2
* @copyright (c) 2008 phpBB3.PL Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

include($phpbb_root_path . 'includes/OAPI/OAPI.' . $phpEx);

OAPI::prepare(7);
OAPI::loadLang('mods/chat');

$method = request_var('mode', '');

if (is_callable(array('Chat_ExternalAPI', $method)))
{
	Chat_ExternalAPI::$method();
}
else
{
	throw new OAPI_Exception('ModeNotSupported', 'Script', array('mode' => $method));
}

/**
 * External API for the chat.
 *
 * @package Chat
**/
class Chat_ExternalAPI
{
	public static function getNew()
	{
		$chat = new Chat();
		$chat->messagesFilter = 'c.message_id > ' . request_var('messageID', 0);
		$chat->displayXML();
	}

	public static function post()
	{
		$message = new Chat_Message();

		$message->text = new Fields_Textarea_Normal('message');
		$message->text->maxLength = 250;
		$message->text->text      = request_var('message', '', true);
		$message->text->options   = array('allowBBCode' => true, 'allowURLs' => true, 'allowSmilies' => true);

		$message->time = new Time();

		global $user;

		$message->author = new UserInfo();
		$message->author->ID    = $user->data['user_id'];
		$message->author->name  = ($user->data['user_id'] == ANONYMOUS) ? request_var('guestname', '', true) : $user->data['username'];
		$message->author->color = $user->data['user_colour'];

		$message->post();

		throw new OAPI_Exception('Chat::MessagePosted', 'OK');
	}

	public static function delete()
	{
		$messageID = request_var('messageID', 0);
		Chat::deleteMessage($messageID);

		throw new OAPI_Exception('Chat::MessageDeleted', 'OK', array('messageID' => $messageID));
	}
}