/*

 $Id: $

*/


/*
	Table: 'phpbb_chat'
*/
CREATE TABLE phpbb_chat (
	message_id number(8) NOT NULL,
	message clob DEFAULT '' ,
	message_uid varchar2(8) DEFAULT '' ,
	message_bitfield varchar2(255) DEFAULT '' ,
	message_options number(11) DEFAULT '7' NOT NULL,
	message_time number(11) DEFAULT '0' NOT NULL,
	user_id number(8) DEFAULT '0' NOT NULL,
	guestname varchar2(765) DEFAULT '0' NOT NULL,
	CONSTRAINT pk_phpbb_chat PRIMARY KEY (message_id)
)
/

CREATE INDEX phpbb_chat_message_time ON phpbb_chat (message_time)
/

CREATE SEQUENCE phpbb_chat_seq
/

CREATE OR REPLACE TRIGGER t_phpbb_chat
BEFORE INSERT ON phpbb_chat
FOR EACH ROW WHEN (
	new.message_id IS NULL OR new.message_id = 0
)
BEGIN
	SELECT phpbb_chat_seq.nextval
	INTO :new.message_id
	FROM dual;
END;
/


